/*
 *>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
 *              HSP̎st@CUPXňk邽߂̃c[
 *                     hspcmpx ver.0.5a \[Xt@C
 *
 *  by THAGA
 *<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 */

#ifdef DEBUG
#include <stdio.h>
#endif
#include <windows.h>
#include <limits.h>

#define myPrint(putstr) WriteConsole(conout, putstr, lstrlen(putstr), &dummy, NULL)
#define isDirDelimiter(p) ((*p == '\\' && !((0x81 <= *(p - 1) && *(p - 1) <= 0x9f)\
 || (0xe0 <= *(p - 1) && *(p - 1) <= 0xf5))) || *p == '/')

#define HSPCMPX_BACKUP 0x01
#define HSPCMPX_MAKE 0x02
#define HSPCMPX_DOUBLE 0x04
#define HSPCMPX_NOCOMPRESSION 0x08
#define HSPCMPX_EXECUTABLE 0x10

#define HSPCMPX_MAX_PATH 1024

#ifdef DEBUG
FILE *logfile;
#endif

/*
typedef struct{
	char *scriptfile;
	char *exefile = NULL;
	char *compath = NULL;
	char *refname = NULL;
	char *objname = NULL;
	char *dpmname = NULL;
	char *hsprt = NULL;
	char copt1 = 0;
	char copt2 = 0;
	char copt3 = 0;
	char dpmtype = 0;
	char type = 0;
	char invisible = 0;
	int xsize = 0;
	int ysize = 0;
} HSPCMP_CONFIG;
*/

char level = 0, delflag = 0, type = 0, invisible = 0, automake = 0, ftflag = 0, killmacro = 0;
int xsize = 0, ysize = 0;
char *inname = NULL;
char *outname = NULL;
char *upx = "upx.exe";
char *hspcmp = NULL;
char *cmdline = NULL;
char *objname = NULL;
char *runtime = NULL;
char *compath = NULL;
char tmpname[HSPCMPX_MAX_PATH];
char exedir[HSPCMPX_MAX_PATH];
char innamebuf[HSPCMPX_MAX_PATH];
char outnamebuf[HSPCMPX_MAX_PATH];
char hspcmpbuf[HSPCMPX_MAX_PATH];
char upxpath[HSPCMPX_MAX_PATH];

DWORD dummy;
STARTUPINFO sinfo;
PROCESS_INFORMATION pinfo;

HANDLE hfile = NULL ,hp = NULL;
HANDLE hPipe1Read, hPipe1Write;
HANDLE hPipe3Read, hPipe3Write;
HANDLE hStdOut, hStdErr;
HANDLE conout;

FILETIME in_ft1, in_ft3;
FILETIME out_ft1, out_ft3;

int (WINAPI * hsc_ini)(int, char *, int, int);
int (WINAPI * hsc_refname)(int, int, int, int);
int (WINAPI * hsc_objname)(int, char *, int, int);
int (WINAPI * hsc_compath)(int, char *, int, int);
int (WINAPI * hsc_comp)(int, int, int, int);
int (WINAPI * hsc_getmes)(char *, int, int, int);
int (WINAPI * hsc_clrmes)(int, int, int, int);
int (WINAPI * hsc_ver)(int, int, int, char *);
int (WINAPI * hsc_bye)(int, int, int, int);
int (WINAPI * pack_ini)(int, char *, int, int);
int (WINAPI * pack_make)(int, int, int, int);
int (WINAPI * pack_exe)(int, int, int, int);
int (WINAPI * pack_opt)(int, int, int, int);
int (WINAPI * pack_rt)(int, char *, int, int);
int (WINAPI * hsc3_make)(int, char *, int, int);

void usage();
int Bmsearch(unsigned char *data, unsigned char *pat, int data_size, int pat_size, int index);
int StartUPX(const char *compbuf, int compsize);
void error(const char *err);
void ChangeExt(unsigned char *fname, const char *ext);
int GetExt(char *ext, unsigned char *fname);
void GetDir(unsigned char *dir, const char *fname);
int GetNum(const char *p);

int main(int argc, char *argv[])
{
	int ratio, flag = 0;
	int fsize, fsize2, fsize3, index;
	char *search = "DPMX";
	char *pbuf;
	char tmpbuf[HSPCMPX_MAX_PATH];
	HINSTANCE hdll;

	conout = GetStdHandle(STD_OUTPUT_HANDLE);

	if (argc == 1)
		usage();

	GetDir(exedir, argv[0]);
	SetCurrentDirectory(exedir);

/* R}hC */
	for (index = 1; index < argc; index++)
	{
		if (*argv[index] == '-')
		{
			if (*(argv[index] + 2) != '\0')
			{
				switch (*(argv[index] + 1))
				{
					case 'x':
						xsize = GetNum(argv[index] + 2);
						if (xsize == -1)
						{
							xsize = 0;
							break;
						}
						continue;
					case 'y':
						ysize = GetNum(argv[index] + 2);
						if (ysize == -1)
						{
							ysize = 0;
							break;
						}
						continue;
					case 't':
						type = GetNum(argv[index] + 2);
						if (type == -1)
						{
							type = 0;
							break;
						}
						continue;
					default:
						break;
				}
			}
			else
			{
				switch (*(argv[index] + 1))
				{
					case '1':
						level = 1;
						continue;
					case '2':
						level = 2;
						continue;
					case '3':
						level = 3;
						continue;
					case '4':
						level = 4;
						continue;
					case '5':
						level = 5;
						continue;
					case '6':
						level = 6;
						continue;
					case '7':
						level = 7;
						continue;
					case '8':
						level = 8;
						continue;
					case '9':
						level = 9;
						continue;
					case 'b':
						flag |= HSPCMPX_BACKUP;
						continue;
					case 'm':
						flag |= HSPCMPX_MAKE;
						continue;
					case 'd':
						flag |= HSPCMPX_DOUBLE;
						continue;
					case 'n':
						flag |= HSPCMPX_NOCOMPRESSION;
						continue;
					case 'e':
						flag |= HSPCMPX_EXECUTABLE;
						continue;
					case 'i':
						invisible = 1;
						continue;
					case 'a':
						automake = 4;
						continue;
					case 'k':
						killmacro = 1;
						continue;
					default:
						break;
				}
			}
			if (index < argc - 1 && *(argv[index] + 2) == '\0')
			{
				switch (*(argv[index] + 1))
				{
					case 'h':
						lstrcpyn(hspcmpbuf, argv[++index], HSPCMPX_MAX_PATH);
						hspcmp = hspcmpbuf;
						continue;
					case 'u':
						upx = argv[++index];
						if (upx[1] != ':')
						{
							GetFullPathName(upx, HSPCMPX_MAX_PATH, upxpath, NULL);
							upx = upxpath;
						}
						continue;
					case 'c':
						cmdline = argv[++index];
						continue;
					case 'o':
						objname = argv[++index];
						continue;
					case 'r':
						runtime = argv[++index];
						continue;
					case 'p':
						compath = argv[++index];
						continue;
					default:
						break;
				}
			}
		}
		if (!inname)
		{
			lstrcpyn(innamebuf, argv[index], HSPCMPX_MAX_PATH);
			inname = innamebuf;
			if (inname[1] != ':')
				GetFullPathName(inname, HSPCMPX_MAX_PATH, inname, NULL);
		}
		else if (!outname)
		{
			lstrcpyn(outnamebuf, argv[index], HSPCMPX_MAX_PATH);
			outname = outnamebuf;
			if (outname[1] != ':')
				GetFullPathName(outname, HSPCMPX_MAX_PATH, outname, NULL);
		}
	}

#ifdef DEBUG
	logfile = fopen("hspcmpx.log", "w");
	fprintf(logfile, "̓t@C: %s\no̓t@C: %s\n\
UPX: %s\nhspcmp.dll: %s\nǉR}hC :%s\n: %s\n",
		 inname, outname, upx, hspcmp, cmdline, argv[0]);
#endif

	if (!inname)
		usage();

	CreatePipe(&hPipe1Read, &hPipe1Write, NULL, 4096);
	DuplicateHandle(GetCurrentProcess(), hPipe1Write, GetCurrentProcess(), 
		&hStdOut, 0, TRUE, DUPLICATE_CLOSE_SOURCE | DUPLICATE_SAME_ACCESS);

	CreatePipe(&hPipe3Read, &hPipe3Write, NULL, 4096);
	DuplicateHandle(GetCurrentProcess(), hPipe3Write, GetCurrentProcess(), 
		&hStdErr, 0, TRUE, DUPLICATE_CLOSE_SOURCE | DUPLICATE_SAME_ACCESS);

	ZeroMemory(&sinfo, sizeof(sinfo));

	sinfo.cb = sizeof(sinfo);
	sinfo.dwFlags = STARTF_USESTDHANDLES | STARTF_USESHOWWINDOW;
	sinfo.wShowWindow = SW_HIDE;
	sinfo.hStdOutput = hStdOut;
	sinfo.hStdError = hStdErr;

	GetExt(tmpbuf, inname);
	if ((lstrcmpi("as", tmpbuf) == 0 || lstrcmpi("hsp", tmpbuf) == 0)
		 && !(flag & HSPCMPX_EXECUTABLE))
		flag |= HSPCMPX_MAKE;

	if (flag & HSPCMPX_MAKE)
	{
		char a;
		char *dllname = "hspcmp.dll";
		char compathbuf[HSPCMPX_MAX_PATH];
		char runtimebuf[HSPCMPX_MAX_PATH];
		char objnamebuf[HSPCMPX_MAX_PATH];
		char asdir[HSPCMPX_MAX_PATH];

		GetDir(asdir, inname);

		if (hspcmp)
		{
			SetCurrentDirectory(hspcmp);
			hdll = LoadLibrary(dllname);
			if (!hdll)
				error("hspcmp.dllw肳ꂽtH_ɂ܂");
		}
		else
		{
			SetCurrentDirectory(asdir);
			hdll = LoadLibrary(dllname);
			if (!hdll)
			{
				SetCurrentDirectory(exedir);
				hdll = LoadLibrary(dllname);
				if (!hdll)
					error("hspcmp.dllǂݍ߂܂ł");
				lstrcpyn(hspcmpbuf, exedir, HSPCMPX_MAX_PATH);
			}
			else
				lstrcpyn(hspcmpbuf, asdir, HSPCMPX_MAX_PATH);
		}
		SetCurrentDirectory(exedir);
		if (hspcmpbuf[1] != ':')
			GetFullPathName(hspcmpbuf, HSPCMPX_MAX_PATH, hspcmpbuf, NULL);

		hsc_ini = GetProcAddress(hdll, "_hsc_ini@16");
		hsc_objname = GetProcAddress(hdll, "_hsc_objname@16");
		hsc_compath = GetProcAddress(hdll, "_hsc_compath@16");
		hsc_comp = GetProcAddress(hdll, "_hsc_comp@16");
		hsc_getmes = GetProcAddress(hdll, "_hsc_getmes@16");
		hsc_clrmes = GetProcAddress(hdll, "_hsc_clrmes@16");
		hsc_ver = GetProcAddress(hdll, "_hsc_ver@16");
		hsc_bye = GetProcAddress(hdll, "_hsc_bye@16");
		pack_ini = GetProcAddress(hdll, "_pack_ini@16");
		pack_make = GetProcAddress(hdll, "_pack_make@16");
		pack_exe = GetProcAddress(hdll, "_pack_exe@16");
		pack_opt = GetProcAddress(hdll, "_pack_opt@16");
		pack_rt = GetProcAddress(hdll, "_pack_rt@16");

		myPrint("\nXNvgst@C쐬Ă܂\n");

		if (runtime)
		{
			if (runtime[1] != ':')
				GetFullPathName(runtime, HSPCMPX_MAX_PATH, runtimebuf, NULL);
			else
				lstrcpyn(runtimebuf, runtime, HSPCMPX_MAX_PATH);
		}
		else
		{
			lstrcpyn(runtimebuf, hspcmpbuf, HSPCMPX_MAX_PATH);
			lstrcat(runtimebuf, "\\hsprt");
		}

		if (compath)
		{
			if (compath[1] != ':')
				GetFullPathName(compath, HSPCMPX_MAX_PATH, compathbuf, NULL);
			else
				lstrcpyn(compathbuf, compath, HSPCMPX_MAX_PATH);
			lstrcat(compathbuf, "\\");
		}
		else
		{
			lstrcpyn(compathbuf, hspcmpbuf, HSPCMPX_MAX_PATH);
			lstrcat(compathbuf, "\\common\\");
		}

		if (objname)
		{
			if (objname[1] != ':')
				GetFullPathName(objname, HSPCMPX_MAX_PATH, objnamebuf, NULL);
			else
				lstrcpyn(objnamebuf, objname, HSPCMPX_MAX_PATH);
		}
		else
		{
			lstrcpyn(objnamebuf, asdir, HSPCMPX_MAX_PATH);
			lstrcat(objnamebuf, "\\start.ax");
		}

		SetCurrentDirectory(asdir);

		hsc_ini(0, inname, 0, 0);
		hsc_objname(0, objnamebuf, 0, 0);
		hsc_compath(0, compathbuf, 0, 0);
		hsc_ver(0, 0, 0, tmpbuf);
		myPrint(tmpbuf);
		myPrint("\n\n");
		a = hsc_comp(0, automake + killmacro, 0, 0);
		hsc_getmes(tmpbuf, 0, 0, 0);
		myPrint(tmpbuf);
		if (a)
			error("RpCɎs܂");
		else
			myPrint("\nRpCɐ܂");
		hsc_bye(0, 0, 0, 0);

		lstrcat(inname, ".i");
		DeleteFile(inname);	/* ԃR[h̍폜 */
		ChangeExt(inname, NULL);
		ChangeExt(inname, NULL);

		pack_ini(0, inname, 0, 0);
		pack_make(0, 0, 0, 0);
		pack_opt(xsize, ysize, invisible, 0);
		pack_rt(0, runtimebuf, 0, 0);
		if (automake)
		{
			hsc3_make = GetProcAddress(hdll, "_hsc3_make@16");
			if (!hsc3_make)
				error("HSP̃o[Wł͎st@C̎쐬̓T|[gĂ܂");
			lstrcat(hspcmpbuf, "\\");
			a = hsc3_make(0, hspcmpbuf, 0, 0);
		}
		else
			a = pack_exe(type, 0, 0, 0);
		hsc_getmes(tmpbuf, 0, 0, 0);
		myPrint("\n\n");
		myPrint(tmpbuf);
		if (a)
			error("st@C쐬Ɏs܂");
		else
			myPrint("\nst@C쐬ɐ܂");

		FreeLibrary(hdll);

		lstrcat(inname, ".dpm");
		DeleteFile(inname);	/* DPMt@C̍폜 */
		ChangeExt(inname, "exe");
		if (type == 2)
			ChangeExt(inname, "scr");

		SetCurrentDirectory(exedir);
		myPrint("\nst@C쐬\n");
	}

	hfile = CreateFile(inname, GENERIC_READ, FILE_SHARE_WRITE, NULL, OPEN_EXISTING, 0, 0);
	if (hfile == INVALID_HANDLE_VALUE)
		error("̓t@CJ܂ł");

	fsize = GetFileSize(hfile, NULL);

	if (flag & HSPCMPX_NOCOMPRESSION)
	{
		wsprintf(tmpbuf, "\nks킸ɏI܂\
\n  t@CTCYF%d\n  t@C: %s",
			fsize, inname);
		myPrint(tmpbuf);
		return 0;
	}

	hp = HeapCreate(0, fsize, 0);
	if (!hp)
		error("obt@mۂł܂ł");

	pbuf = HeapAlloc(hp, HEAP_ZERO_MEMORY, fsize);
	ReadFile(hfile, pbuf, fsize, &dummy, 0);
	GetFileTime(hfile, &in_ft1, NULL, &in_ft3);
	CloseHandle(hfile);

/* wb_"DPMX"̌ */
	fsize2 = Bmsearch(pbuf, search, fsize, 4, 0);
	fsize2 = Bmsearch(pbuf, search, fsize, 4, fsize2 + 4);
	if (flag & HSPCMPX_DOUBLE)	/* ^CɂĂ"DPMX"x邱Ƃ */
		fsize2 = Bmsearch(pbuf, search, fsize, 4, fsize2 + 4);
	if (fsize2 < 0)
		error("̓t@CHSPst@Cł͂܂(1)");

#ifdef DEBUG
	fprintf(logfile, "t@CTCY:%d\nDPMXꏊ:%d\n", fsize, fsize2);
#endif

	if (!outname)
		outname = inname;

/* ̓t@C𒲂ׂ܂ł̓obNAbvȂ */
	hfile = CreateFile(outname, GENERIC_READ, FILE_SHARE_WRITE, NULL, OPEN_EXISTING, 0, 0);
	if (hfile != INVALID_HANDLE_VALUE)
	{
		ftflag = 1;
		GetFileTime(hfile, &out_ft1, NULL, &out_ft3);
		CloseHandle(hfile);
		GetTempFileName(".", "hsp", 0, tmpname);
		if (!CopyFile(outname, tmpname, FALSE))
			myPrint("\nx: e|t@C̍쐬Ɏs܂B\
ksɏo̓t@C͕܂\n");
	}

	if (flag & HSPCMPX_BACKUP)
	{
		lstrcpyn(tmpbuf, outname, HSPCMPX_MAX_PATH);
		ChangeExt(tmpbuf, "bak");
		if (!CopyFile(outname, tmpbuf, FALSE))
			myPrint("\nx: obNAbv̍쐬Ɏs܂B𑱂܂\n");
		hfile = CreateFile(tmpbuf, GENERIC_WRITE, FILE_SHARE_WRITE, NULL, OPEN_EXISTING, 0, 0);
		SetFileTime(hfile, &out_ft1, NULL, &out_ft3);
		CloseHandle(hfile);
	}

	myPrint("\nUPXɂ鈳kJn܂\n");

	if (StartUPX(pbuf, fsize2))
		error("UPX̎sɎs܂(1 pass)");
	hfile = CreateFile(outname, GENERIC_READ, FILE_SHARE_WRITE, NULL ,OPEN_EXISTING, 0, 0);
	fsize3 = GetFileSize(hfile, NULL);
	CloseHandle(hfile);
	if (fsize3 == fsize2)
		error("UPXkɎs܂(1 pass)");

	wsprintf(tmpbuf, "%d", fsize2 - 0x10000);
#ifdef DEBUG
	fprintf(logfile, "k̃TCY:%d\n:%s\n", fsize3, tmpbuf);
#endif
	index = Bmsearch(pbuf, tmpbuf, fsize, lstrlen(tmpbuf), 0);
	if (index < 0)
		error("̓t@CHSP̎st@Cł͂܂(2)");

	delflag = 1;	/* ȍ~̓G[ɏo̓t@C폜 */

	ZeroMemory(pbuf + index, 10);

	wsprintf(tmpbuf, "%d", fsize3 - 0x10000);
#ifdef DEBUG
	fprintf(logfile, "ރCfbNX: %s\n", tmpbuf);
#endif
	CopyMemory(pbuf + index, tmpbuf, lstrlen(tmpbuf));

	if (StartUPX(pbuf, fsize2))
		error("UPX̎sɎs܂(2 pass)");

	hfile = CreateFile(outname, GENERIC_READ, FILE_SHARE_WRITE,NULL ,OPEN_EXISTING,0,0);
	ReadFile(hfile, pbuf, fsize3, &dummy, 0);
	CloseHandle(hfile);

	CopyMemory(pbuf + fsize3, pbuf + fsize2, fsize - fsize2);

	hfile = CreateFile(outname, GENERIC_WRITE, FILE_SHARE_WRITE, NULL ,CREATE_ALWAYS,0,0);
	if (!WriteFile(hfile, pbuf, fsize3 + fsize - fsize2, &dummy, NULL))
		error("o̓t@C̍쐬Ɏs܂");
	SetFileTime(hfile, &in_ft1, NULL, &in_ft3);
	CloseHandle(hfile);

	ratio = (fsize3 + fsize - fsize2) * 100 / fsize;

	DeleteFile(tmpname);

	CloseHandle(hPipe1Read);
	CloseHandle(hPipe3Read);
	CloseHandle(hStdOut);
	CloseHandle(hStdErr);
	HeapDestroy(hp);

	wsprintf(tmpbuf, "\nt@C̈kɐ܂\
\n  TCY: %d\n  kTCY: %d\n  k: %d%%\n  o̓t@C: %s",
		fsize, fsize3 + fsize - fsize2, ratio, outname);
	myPrint(tmpbuf);

#ifdef DEBUG
	fclose(logfile);
#endif

	return 0;
}

/*
  g̕\
*/
void usage()
{
	myPrint("\n  hspcmpx <inputfile> [<outputfile>] [-u <upxpath>]\
 [-h <hspcmppath>] [-c <cmdline>] [-123456789] [-b] [-m] [-e] [-d] [-n]\
 [-x<xsize>] [-y<ysize>] [-t012] [-i] [-o <objname>] [-r <runtime>] [-p <compath>] [-a] [-k]\
\n\n  <inputfile>\t̓t@C\
\n  <outputfile>\t쐬t@CBȗ͓̓t@CƓ\
\n  -u <upxpath>\tUPX̏ꏊ(tpXhspcmpx.exȅꏊ̑΃pX)Bȗ\"upx.exe\"\
\n  -h <hspcmppath>\t\"hspcmp.dll\"̂tH_\
\n  -c <cmdline>\tUPXɒǉœnR}hC\
\n  -123456789\tUPXk(1-9)Bȗƍōk\
\n  -b\t\tkt@C̃obNAbv\
\n  -m\t\t̓t@CHSPXNvgt@CƂ݂Ȃst@C쐬\
\n  -e\t\t̓t@Cst@CƂ݂Ȃ\
\n  -d\t\tHRT_IRWgst@Ckꍇt\
\n  -n\t\tksȂ\
\n\n  ȉ͎st@C쐬̃IvV\
\n  -x<xsize>\t쐬st@C̏EBhETCY(sNZP)\
\n  -y<ysize>\t쐬st@C̏EBhEcTCY(sNZP)\
\n  -t012\t\t쐬st@C̃^Cv(0-2)B0 ͒ʏ̎st@CA1 ̓tXN\
[̎st@CA2 ̓XN[Z[o[Bȗ0\
\n  -i\t\t쐬st@C̃EBhEԂŉB\
\n  -o <objname>\tIuWFNgt@C̖OBȗ\"start.ax\"\
\n  -r <runtime>\t^Ct@CBȗ\"hsprt\"\
\n  -p <compath>\tcommonfBNgBȗ\"common\"\
\n  -a\t\tst@C̎쐬s\
\n  -k\t\tHSPg}NgpȂ\
");

	ExitProcess(0);
}

/*
  ȗBM@Ńf[^A擪̃CfbNXԂ
*/
int Bmsearch(unsigned char *data, unsigned char *pat, int data_size, int pat_size, int index)
{
	int pd, pp, skip[UCHAR_MAX + 1];
	for(pd = 0; pd <= UCHAR_MAX; pd++)
		skip[pd] = pat_size;
	for(pd = 0; pd < pat_size - 1 ;pd++)
		skip[pat[pd]] = pat_size - pd - 1;
	pd += index;
	while(pd < data_size)
	{
		pp = pat_size - 1;
		while(data[pd] == pat[pp])
		{
			if(pp == 0)
				return pd;
			pp--;
			pd--;
		}
		pd += skip[data[pd]];
	}
	return -1;
}

/*
  UPXĂяo
*/
int StartUPX(const char *compbuf, int compsize)
{
	char command[4096];
	HANDLE houtname = CreateFile(outname, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, 0, 0);

	if (!WriteFile(houtname, compbuf, compsize, &dummy, NULL))
	{
		CloseHandle(houtname);
		return 1;
	}
	CloseHandle(houtname);

	if (level)
		wsprintf(command, " \"%s\" -%d -f", outname, level);
	else
		wsprintf(command, " \"%s\" --best -f", outname);

	if (!cmdline)
		lstrcat(command, cmdline);

#ifdef DEBUG
	fprintf(logfile, "UPXɓnR}h: %s\n", command);
#endif

	if (!CreateProcess(upx, command, NULL, NULL, TRUE,
		 NORMAL_PRIORITY_CLASS, NULL, NULL, &sinfo, &pinfo))
		return 1;

	WaitForSingleObject(pinfo.hProcess, INFINITE);
	PeekNamedPipe(hPipe3Read, command, 4096, &dummy, NULL, NULL);
	if (dummy)
	{
		lstrcat(command, "\n");
		myPrint(command);
		return 1;
	}

#ifdef DEBUG
	fprintf(logfile, "%s\n", command);
#endif

	return 0;
}

/*
  G[\Ãt@C𕜌
*/
void error(const char *err)
{
	char errmsg[256];
	HANDLE houtfile;

	if (delflag)
		DeleteFile(outname);

	CloseHandle(hfile);
	CloseHandle(hPipe1Read);
	CloseHandle(hPipe3Read);
	CloseHandle(hStdOut);
	CloseHandle(hStdErr);
	HeapDestroy(hp);

	lstrcpyn(errmsg, "\nError: ", 256);
	lstrcat(errmsg, err);

#ifdef DEBUG
	fprintf(logfile, errmsg);
	fclose(logfile);
#endif

	myPrint(errmsg);

	if (ftflag == 1 && delflag == 1)
	{
		if (!CopyFile(tmpname, outname, FALSE))
			myPrint("\no̓t@C̕Ɏs܂");
		else
			myPrint("\no̓t@C𕜌܂");
		houtfile = CreateFile(outname, GENERIC_WRITE, FILE_SHARE_WRITE, NULL, OPEN_EXISTING, 0, 0);
		SetFileTime(houtfile, &out_ft1, NULL, &out_ft3);
		CloseHandle(houtfile);
	}
	DeleteFile(tmpname);

	ExitProcess(0);
}

/*
  gq̕ύX
*/
void ChangeExt(unsigned char *fname, const char *ext)
{
	unsigned char *p, *pp;
	pp = fname + lstrlen(fname);
	p = pp - 1;

	for(;;)
	{
		if (*p == '.')
			pp = p;
		if (p == fname)
			break;
		if (isDirDelimiter(p))
			break;
		p--;
	}

	*pp = '\0';

	if (ext)
	{
		lstrcat(fname, ".");
		lstrcat(fname, ext);
	}
}

/*
  gq̎擾
*/
int GetExt(char *ext, unsigned char *fname)
{
	unsigned char *p;
	p = fname + lstrlen(fname) - 1;

	for(;;)
	{
		if (*p == '.')
			break;
		if (p == fname)
			return 1;
		if (isDirDelimiter(p))
			return 1;
		p--;
	}

	lstrcpy(ext, p + 1);
	return 0;
}


/*
  t@ĈfBNg̎擾
*/
void GetDir(unsigned char *dir, const char *fname)
{
	unsigned char *p;

	lstrcpy(dir, fname);
	p = dir + lstrlen(dir) - 1;

	for(;;)
	{
		if (p == dir)
		{
			*p = '.';/* t@Ĉ݂Ȃ΃JgfBNgԂ */
			p++;
			break;
		}
		if (isDirDelimiter(p))
			break;
		p--;
	}

	*p = '\0';
}

/*
  𐔒l
*/
int GetNum(const char *p)
{
	int num = 0;
	while(*p != '\0')
	{
		if (!('0' <= *p && *p <= '9'))
		{
			num = -1;
			break;
		}
		num *= 10;
		num += *p - '0';
		p++;
	}
	return num;
}
